/* =========================================================================================================
  Script Revive ADO : revive_actions.sqf
  Version: 1.5
  Auteur: The-KiLLeR (www.clan-ado.fr / killouze@hotmail.fr)
========================================================================================================= */
/*
	ADO_REVIVE_statut
	ADO_REVIVE_joueur_%1

	0 = Rien
	1 = Attente réanimation
	2 = Réanimer
	3 = Trainer
	4 = Porter
	5 = Caisse
*/
private ["_blesse","_secouriste","_type"];

ADO_REVIVE_annulerAction = false;

_blesse = _this select 0;
_secouriste = _this select 1;
_type = _this select 3;

if (typeName _type == "ARRAY") then {
	_type = _type select 0;
};

_secouristeStatut = call compile format["ADO_REVIVE_joueur_%1",_secouriste];

if (_secouriste distance _blesse > 3 && _type != 11 && _type != 12) exitWith { _secouriste groupChat "Vous êtes trop loin pour faire cette action"; };
if (_secouristeStatut != 0 && (_secouristeStatut != 5 && _type != 9)) exitWith { _secouriste groupChat "Vous ne pouvez pas faire cette action !"; };

// Action "Réanimer"
if (_type == 2) then {

	call compile format["ADO_REVIVE_joueur_%1 = 2; publicVariable 'ADO_REVIVE_joueur_%1'",_blesse];

	_medic = getNumber(configFile >> "cfgVehicles" >> (typeOf _secouriste) >> "attendant");
	if (_medic == 1) then {
		call compile format["ADO_REVIVE_medic_%1 = 1; publicVariable 'ADO_REVIVE_medic_%1'",_blesse];
	};
	
	_secouriste attachTo [_blesse,[-0.7,0.2,0]];
	_secouriste setDir 90;
	//_secouriste playMove "AinvPknlMstpSnonWrflDnon_medic";
	//sleep 1;
	_secouriste switchMove "AinvPknlMstpSnonWrflDnon_medic3";
	
	for [{_i = 0},{_i < 20},{_i = _i + 1}] do {
		if (ADO_REVIVE_annulerAction) exitWith {};
	   sleep 1;
	};
	
	if (!alive _secouriste || !alive _blesse || ADO_REVIVE_annulerAction) exitWith {
		_secouriste switchMove "";
		detach _secouriste;
		call compile format["ADO_REVIVE_joueur_%1 = 1; publicVariable 'ADO_REVIVE_joueur_%1'",_blesse];
		ADO_REVIVE_annulerAction = false;
	};
	
	_secouriste playMove "AinvPknlMstpSnonWrflDnon_medicEnd";
	
	detach _secouriste;
	call compile format["ADO_REVIVE_joueur_%1 = 0; publicVariable 'ADO_REVIVE_joueur_%1'",_blesse];
	
	_message = format["vient de se faire réanimer par %1",name _secouriste];
	[_blesse, nil, rSIDECHAT, _message] call RE;
};

// Action "Trainer le corps"
if (_type == 3) then {

	call compile format["ADO_REVIVE_joueur_%1 = 3; publicVariable 'ADO_REVIVE_joueur_%1'",_blesse];

	actionSecouriste = _secouriste addAction ["<t color='#e5ac11'>Lacher le corps</t>","ADO_revive\revive_actions.sqf",[1,_blesse]];
	
	_secouriste playMove "acinpknlmstpsraswrfldnon";
	sleep 2;
	_blesse switchMove "ainjppnemstpsnonwrfldb_still";
	sleep 0.2;
	_blesse attachTo [_secouriste,[0.1, 1.01, 0]];

	call compile format ["%1 setVehicleInit '%1 = this; this setDir 180;'",_blesse];
	processInitCommands;
	
	waitUntil {call compile format["ADO_REVIVE_joueur_%1",_blesse] == 1 || ADO_REVIVE_annulerAction || !alive _blesse || !alive _secouriste};
	
	if (call compile format["ADO_REVIVE_joueur_%1",_blesse] != 1) then {
		call compile format["ADO_REVIVE_joueur_%1 = 1; publicVariable 'ADO_REVIVE_joueur_%1'",_blesse];
		_secouriste removeAction actionSecouriste;
	};
	
	detach _blesse;
	_secouriste switchMove "";
	ADO_REVIVE_annulerAction = false;
};

// Action "Porter le corps"
if (_type == 4) then {

	call compile format["ADO_REVIVE_joueur_%1 = 4; publicVariable 'ADO_REVIVE_joueur_%1'",_blesse];

	actionSecouriste = _secouriste addAction ["<t color='#e5ac11'>Lacher le corps</a>","ADO_revive\revive_actions.sqf",[1,_blesse]];
	
	_secouriste switchMove "acinpknlmstpsraswrfldnon_acinpercmrunsraswrfldnon";
	_blesse switchMove "ainjpfalmstpsnonwrfldnon_carried_up";
	
	[nil, _blesse, rSWITCHMOVE, "ainjpfalmstpsnonwrfldnon_carried_up"] call RE;
	
	sleep 0.2;
	_blesse attachTo [_secouriste,[0.2,0.2,0.1]];
	
	call compile format ["%1 setVehicleInit '%1 = this; this setDir 180;'",_blesse];
	processInitCommands;
	
	waitUntil {animationState _secouriste == "acinpercmstpsraswrfldnon"};
	sleep 1;
	waitUntil {call compile format["ADO_REVIVE_joueur_%1",_blesse] == 1 || ADO_REVIVE_annulerAction || !alive _blesse || !alive _secouriste || (animationState _secouriste != "acinpercmrunsraswrfldf" && animationState _secouriste != "acinpercmstpsraswrfldnon" && animationState _secouriste != "acinpknlmstpsraswrfldnon_acinpercmrunsraswrfldnon")};
	
	_secouriste switchMove "AcinPercMrunSrasWrflDf_AmovPercMstpSlowWrflDnon";
	_blesse switchMove "AinjPfalMstpSnonWrflDnon_carried_down";
	[nil, _blesse, rSWITCHMOVE, "AinjPfalMstpSnonWrflDnon_carried_down"] call RE;
	
	detach _blesse;

	if (call compile format["ADO_REVIVE_joueur_%1",_blesse] != 1) then {
		call compile format["ADO_REVIVE_joueur_%1 = 1; publicVariable 'ADO_REVIVE_joueur_%1'",_blesse];
		_secouriste removeAction actionSecouriste;
	};
	
	waitUntil {animationState _secouriste != "AcinPercMrunSrasWrflDf_AmovPercMstpSlowWrflDnon"};
	_secouriste switchMove "";
	ADO_REVIVE_annulerAction = false;
};

// Action "Lacher le corps"
if (_type == 1) then {

	_blesse = (_this select 3) select 1;
	call compile format["ADO_REVIVE_joueur_%1 = 1; publicVariable 'ADO_REVIVE_joueur_%1'",_blesse];
	
	player removeAction actionSecouriste;
};

// Création tente
if (_type == 5) then {
	
	[nil, _secouriste, rSWITCHMOVE, "RepairingKneel"] call RE;
	
	ADO_REVIVE_sac_statut = [1,_blesse,_secouriste];
	publicVariable "ADO_REVIVE_sac_statut";
	
	sleep 11;
	[nil, _secouriste, rSWITCHMOVE, ""] call RE;
};

// Prendre sac
if (_type == 13) then {
	
	_num = (_this select 3) select 1;
	
	_sac = unitBackpack _secouriste;
	if (!isNull _sac) exitWith {
		_secouriste groupChat "Vous ne pouvez pas prendre la tente car vous avez déjà un sac à dos !";
	};
	
	if (_num == 1) then {
		ADO_REVIVE_sac_joueur1 = _secouriste;
		publicVariable "ADO_REVIVE_sac_joueur1";
		_secouriste action ["TakeBag", ado_sac_respawn_1]; 
	} else {
		ADO_REVIVE_sac_joueur2 = _secouriste;
		publicVariable "ADO_REVIVE_sac_joueur2";
		_secouriste action ["TakeBag", ado_sac_respawn_2];
	};
};

// Prendre tente
if (_type == 6) then {

	[nil, _secouriste, rSWITCHMOVE, "RepairingKneel"] call RE;

	ADO_REVIVE_sac_statut = [2,_blesse,_secouriste];
	publicVariable "ADO_REVIVE_sac_statut";

	sleep 11;
	[nil, _secouriste, rSWITCHMOVE, ""] call RE;
};

// Déplacer caisse
if (_type == 7) then {
	
	if (call compile format["ADO_REVIVE_joueur_%1",_secouriste] == 5) exitWith {};
	_num = (_this select 3) select 1;
	
	call compile format["ADO_REVIVE_joueur_%1 = 5; publicVariable 'ADO_REVIVE_joueur_%1'",_secouriste];
	
	_arme = primaryWeapon _secouriste;

	[nil, _secouriste, rSWITCHMOVE, "AidlPercMstpSnonWnonDnon04"] call RE;
	if (_arme != "") then {_secouriste removeWeapon _arme;};
	
	_blesse attachTo [_secouriste,[0,1,1]];
	
	actionCaisse1 = _secouriste addAction ["<t color='#e5ac11'>Lacher caisse</t>","ADO_revive\revive_actions.sqf",9];
	
	if (_num == 1) then {
		ADO_REVIVE_caisse_statut1 = 1;
		publicVariable "ADO_REVIVE_caisse_statut1";
		actionCaisse2 = _secouriste addAction ["<t color='#e5ac11'>Charger caisse 1</t>","ADO_revive\revive_actions.sqf",[11,1],1,false,false,"","ADO_REVIVE_caisse_statut1 == 1 && (nearestObjects [position player,['Car','Air','Ship'], 5] select 0) distance player <= 5"];
		ADO_REVIVE_caisse_joueur1 = _secouriste;
		publicVariable "ADO_REVIVE_caisse_joueur1";
	} else {
		ADO_REVIVE_caisse_statut2 = 1;
		publicVariable "ADO_REVIVE_caisse_statut2";
		actionCaisse2 = _secouriste addAction ["<t color='#e5ac11'>Charger caisse 2</t>","ADO_revive\revive_actions.sqf",[11,2],1,false,false,"","ADO_REVIVE_caisse_statut2 == 1 && (nearestObjects [position player,['Car','Air','Ship'], 5] select 0) distance player <= 5"];
		ADO_REVIVE_caisse_joueur2 = _secouriste;
		publicVariable "ADO_REVIVE_caisse_joueur2";
	};
	
	waitUntil {call compile format["ADO_REVIVE_joueur_%1",_secouriste] == 0 || !alive _blesse || !alive _secouriste || vehicle _secouriste != _secouriste};

	call compile format["ADO_REVIVE_joueur_%1 = 0; publicVariable 'ADO_REVIVE_joueur_%1'",_secouriste];
	
	_pos = getPosATL _secouriste;
	_dir = getDir _secouriste;
	detach _blesse;
	
	if (vehicle _secouriste != _secouriste) then {
		_blesse setPos [(_pos select 0)+(-5*sin _dir),(_pos select 1)+(-5*cos _dir), 0];
		player removeAction actionCaisse1;
		player removeAction actionCaisse2;
		doGetOut player;
		player action ["eject",(vehicle player)];
	} else {
		_blesse setPos [(_pos select 0)+(1*sin _dir), (_pos select 1)+(1*cos _dir), _pos select 2];
	};
	
	if (_arme != "") then {
		_secouriste addWeapon _arme;
		_secouriste selectWeapon _arme;
	};
	
	[nil, _secouriste, rSWITCHMOVE, ""] call RE;
	
	if (_num == 1) then {
		ADO_REVIVE_caisse_statut1 = 0;
		publicVariable "ADO_REVIVE_caisse_statut1";
		ADO_REVIVE_caisse_joueur1 = objNull;
		publicVariable "ADO_REVIVE_caisse_joueur1";
	} else {
		ADO_REVIVE_caisse_statut2 = 0;
		publicVariable "ADO_REVIVE_caisse_statut2";
		ADO_REVIVE_caisse_joueur2 = objNull;
		publicVariable "ADO_REVIVE_caisse_joueur2";
	};
};

// Déployer camp
if (_type == 8) then {
	
	if (call compile format["ADO_REVIVE_joueur_%1",_secouriste] == 5) exitWith {};
	_num = (_this select 3) select 1;
	
	[nil, _secouriste, rSWITCHMOVE, "RepairingKneel"] call RE;
	
	if (_num == 1) then {
		ADO_REVIVE_caisse_statut1 = 2;
		publicVariable "ADO_REVIVE_caisse_statut1";
	} else {
		ADO_REVIVE_caisse_statut2 = 2;
		publicVariable "ADO_REVIVE_caisse_statut2";
	};
	
	sleep 10;
	[nil, _secouriste, rSWITCHMOVE, ""] call RE;
};

// Lacher caisse
if (_type == 9) then {

	player removeAction actionCaisse1;
	player removeAction actionCaisse2;
	call compile format["ADO_REVIVE_joueur_%1 = 0; publicVariable 'ADO_REVIVE_joueur_%1'",_secouriste];
};

// Ranger camp
if (_type == 10) then {

	if (call compile format["ADO_REVIVE_joueur_%1",_secouriste] == 5) exitWith {};
	_num = (_this select 3) select 1;
	
	[nil, _secouriste, rSWITCHMOVE, "RepairingKneel"] call RE;
	
	if (_num == 1) then {
		ADO_REVIVE_caisse_statut1 = 0;
		publicVariable "ADO_REVIVE_caisse_statut1";
	} else {
		ADO_REVIVE_caisse_statut2 = 0;
		publicVariable "ADO_REVIVE_caisse_statut2";
	};
	
	sleep 10;
	[nil, _secouriste, rSWITCHMOVE, ""] call RE;
};

// Charger caisse
if (_type == 11) then {

	_statut = (_this select 3) select 1;

	player removeAction actionCaisse1;
	player removeAction actionCaisse2;
	call compile format["ADO_REVIVE_joueur_%1 = 0; publicVariable 'ADO_REVIVE_joueur_%1'",player];

	sleep 0.5;
	
	if (_statut == 1) then {
		ADO_REVIVE_caisse_statut1 = 5;
		publicVariable "ADO_REVIVE_caisse_statut1";			
	} else {
		ADO_REVIVE_caisse_statut2 = 5;
		publicVariable "ADO_REVIVE_caisse_statut2";
	};
};

// Décharger caisse
if (_type == 12) then {
	
	if (call compile format["ADO_REVIVE_joueur_%1",_secouriste] == 5) exitWith {};
	
	_statut = (_this select 3) select 1;
	
	if (_statut == 1) then {
		ADO_REVIVE_caisse_statut1 = 0;
		publicVariable "ADO_REVIVE_caisse_statut1";	
	} else {
		ADO_REVIVE_caisse_statut2 = 0;
		publicVariable "ADO_REVIVE_caisse_statut2";
	};
};

if (true) exitWith {};